﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Bee.Util;
using System.Data;
using Bee.Data;
using Bee.Caching;

namespace Bee.BLL
{
    public class AccessWhiteListManager
    {
        private static AccessWhiteListManager instance = new AccessWhiteListManager();

        private static readonly string AuthConnString = ConfigUtil.GetAppSettingValue<string>(Bee.Security.Constants.AuthDbConnectionKey);

        private AccessWhiteListManager()
        {
        }

        public static AccessWhiteListManager Instance
        {
            get
            {
                return instance;
            }
        }

        public bool Check(string controllerName, string actionName)
        {
            DataTable table = CacheManager.Instance.GetEntity<DataTable>("AccessWhiteList", TimeSpan.FromHours(2), () =>
            {
                using (DbSession dbSession = new DbSession(AuthConnString))
                {
                    return dbSession.Query("beeaccesswl", null);
                }
            });


            DataRow[] rows = table.Select("controllername='{0}' and actionname='{1}'".FormatWith(controllerName, actionName));

            return rows.Length > 0;
        }
    }
}
